﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace Maze.Helpers
{
    public class Timer
    {
        public delegate void MethodHandler();

        private MethodHandler method;

        public Timer(MethodHandler methodToTest)
        {
            this.method = methodToTest;
        }

        public void Run(string name)
        {
            var watch = new Stopwatch();
            Debug.WriteLine("Starting " + name);
            watch.Start();

            method.Invoke();

            watch.Stop();

            var ts = watch.Elapsed;
            var elapsedTime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}",
            ts.Hours, ts.Minutes, ts.Seconds,
            ts.Milliseconds / 10);

            Debug.WriteLine("Finished " + name + " in " + elapsedTime);
        }
    }
}
