﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace Maze.Models.Player
{
    public class Player : Renderable
    {
        private Vector3 _movementvector;

        public Player(BGame game) : base(game)
        {
            this.ChangeModel("zDebugBall");
            this.Scale = 0.5f;
        }

        public Player(BGame game, Vector3 position)
            : base(game)
        {
            this.ChangeModel("zDebugBall");
            this.Scale = 0.5f;
            this.Position = position;
        }

        public override void Update()
        {
            Position += _movementvector;
            _movementvector = Vector3.Zero;

            //var dif = new Vector3(1, 1, 50);

            var cam = _game.CameraService.RelativePosition;
            cam.Y = 0;
            var dif = Position - cam;
            dif.Normalize();


            _game.DebugService.AddVector("charpointer", Position, dif * 50);

            base.Update();
        }

        public void Move(KeyboardState currentKeyboardState, KeyboardState previousKeyboardState)
        {
            var cam = _game.CameraService.RelativePosition;
            cam.Y = 0;
            var dif = Position - cam;
            dif.Normalize();

            if (currentKeyboardState.IsKeyDown(Keys.A))
            {

                _movementvector += Vector3.Transform(dif * 5, Matrix.CreateRotationY(MathHelper.ToRadians(90)));
            } else
            if (currentKeyboardState.IsKeyDown(Keys.D))
            {
                _movementvector += Vector3.Transform(dif * 5, Matrix.CreateRotationY(MathHelper.ToRadians(-90)));
            }

            if (currentKeyboardState.IsKeyDown(Keys.W))
            {
                _movementvector += dif * 5;
            } else
            if (currentKeyboardState.IsKeyDown(Keys.S))
            {
                _movementvector += dif * -5;
            }
        }
    }
}
