﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Maze.Models.TileNamespace;
using Maze.Services;
using Microsoft.Xna.Framework;

namespace Maze.Models.SectorNamespace
{
    public interface ISector
    {
        Vector3 Key { get; }
        Guid RoomID { get; set; }
        ISector Preceder { get; set; }
        List<ISector> Successors { get; set; }
        IEnumerable<ISector> Neighbours { get; }
        Directions Directions { get; set; }
        bool IsDeadEnd { get; set; }
        int DistanceToEnd { get; set; }
        Vector3 SectorCoordinate { get; set; }
        Vector3 Coordinate { get; }
        
        void BuildModels();
        void Draw();
        Vector3 GetNeighbour(Directions d);
        float? ScanAndDraw(Ray scanner);
    }
}
