﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using Maze.Models.Maps;
using Maze.Models.SectorNamespace;
using Microsoft.Xna.Framework;
using Maze.Helpers;

namespace Maze.Services
{
    [Flags]
    public enum Directions
    {
        North = 1,
        South = 2,
        East = 4,
        West = 8
    }

    public class EnvironmentService : ServiceBase
    {
        #region constants
        public static int CorridorSize = 3;
        public static int TileSize = 64;
        #endregion
        

        private readonly Random rng = new Random();
        public Map Map { get; set; }
        public ModelLoader ModelLoader { get; set; }

        public EnvironmentService(BGame game) : base(game)
        {
            ModelLoader = new ModelLoader(game);
            Map = new Map(game);

            //var timer = new Timer(() => CarvePassagesFrom(Sectors.Values.First(), 30));
            //timer.Run("Maze");

            //SolveBack(Sectors.Values.Last(), 0, Sectors.Values.First());
            
        }

        public void Update(GameTime gameTime)
        {
            Map.Update(gameTime);

            //if (_lastDetected.DistanceToEnd < 5)
            //{
            //    var buf = Sectors.Values.Last();
            //    foreach (ISector s in Sectors.Values)
            //    {
            //        s.DistanceToEnd += 10;
            //    }
            //    CarvePassagesFrom(Sectors.Values.Where(x => !x.IsDeadEnd).Last(), Sectors.Count + 30);
            //    SolveBack(Sectors.Values.Last(), 0, buf);
            //    Sectors.Values.Where(x => !x.IsDeadEnd).Last().BuildModels();
            //}
        }

        public void Draw()
        {
            Map.Draw();
        }

        //public void CreateRoom(ISector current, int depth)
        //{
        //    if (depth > 0)
        //    {
        //        var d = depth - 1;
        //        var directions = new List<Directions> { Directions.North, Directions.South, Directions.East, Directions.West };
        //        directions.Shuffle(rng);


        //        foreach (var direction in directions)
        //        {
        //            var nextX = current.SectorCoordinate.X + DirectionX[direction];
        //            var nextY = current.SectorCoordinate.Z + DirectionY[direction];
        //            var testpos = new Vector3(nextX, 0, nextY);

        //            if (Sectors.ContainsKey(testpos))
        //            {
        //                //if (Sectors[testpos].Parent == current.Parent)
        //                //{
        //                //    current.Directions |= direction;
        //                //    current.Neighbours.Add(Sectors[testpos]);
        //                //    Sectors[testpos].Directions |= Opposite[direction];
        //                //    Sectors[testpos].Neighbours.Add(current);
        //                //}
        //                continue;
        //            }

        //            current.Directions |= direction;
        //            var newSector = new Sector(_game, testpos, current.Parent);
        //            newSector.IsDeadEnd = true;
        //            newSector.Directions |= Opposite[direction];
        //            newSector.Neighbours.Add(current);
        //            current.Neighbours.Add(newSector);

        //            Sectors.Add(newSector.SectorCoordinate, newSector);
        //            CreateRoom(newSector, d);
        //        }
        //    }
        //}
    }
}
