﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace Maze.Services
{
    public class InformationService : ServiceBase
    {
        private SpriteFont _font;
        public List<string> Lines { get; set; }

        public InformationService(BGame game)
            : base(game)
        {
            _font = _game.Content.Load<SpriteFont>("Content/MainFont");
            Lines = new List<string>();
        }

        public void Update()
        {
            
        }

        public void Draw()
        {
            var height = 20;
            foreach (var line in Lines)
            {
                _game.SpriteBatch.DrawString(_font, line, new Vector2(20, height), Color.White);
                height += 20;
            }
            
        }
    }
}
