﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Maze.Models.Player;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace Maze.Services
{
    public class PlayerService : ServiceBase
    {
        public Player Player { get; private set; }

        public PlayerService(BGame game, Vector3 position)
            : base(game)
        {
            Player = new Player(game, position);
        }

        public void MovePlayer(KeyboardState currentKeyboardState, KeyboardState previousKeyboardState)
        {
            Player.Move(currentKeyboardState, previousKeyboardState);
        }

        public void Update(GameTime gameTime)
        {
            Player.Update();
            string positionstring = "Player Position : x:" + Player.Position.X + "  Y:" + Player.Position.Y + "  Z:" + Player.Position.Z;
            _game.InformationService.Lines.Add(positionstring);
        }

        public void Draw()
        {
            Player.Draw();
        }
    }
}
