
/*** Generated through Lumonix shaderFX  by: Asmodeus in 3dsmax at: 10.09.2011 22:54:19  ***/ 



texture TextureMap_9655
<
	string ResourceName = "test2.png";
	string UIName = "Texture Map";
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_9655Sampler = sampler_state
{
	Texture = <TextureMap_9655>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture TextureMap_9840
<
	string ResourceName = "testspec.png";
	string UIName = "Texture Map";
	string ResourceType = "2D";
>;
 
sampler2D TextureMap_9840Sampler = sampler_state
{
	Texture = <TextureMap_9840>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 
texture NormalMap_2269 : NormalMap
<
	string ResourceName = "testn2.png";
	string UIName = "Normal Map";
	string ResourceType = "2D";
>;
 
sampler2D NormalMap_2269Sampler = sampler_state
{
	Texture = <NormalMap_2269>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = WRAP;
	AddressV = WRAP;
};
 

// this function does the different types of light attenuation 
float attenuation_func(int lightattenType, float4 lightAttenuation, float3 lightVec) 
{ 
	float att = 1.0; 
	return att; 
} 
	 
// this function does the different types of cone angle 
float coneangle_func(int lightconeType, float lightHotspot, float lightFalloff, float3 lightVec, float3 lightDir) 
{ 
	float cone = 1.0; 
	return cone; 
} 

/************** light info **************/ 

float3 light1Dir : Direction 
< 
	string UIName = "Light 1 Direction"; 
	string Object = "TargetLight"; 
	string Space = "World"; 
		int refID = 1; 
> = {100.0f, 100.0f, 100.0f}; 

float3 light1Pos : POSITION 
< 
	string UIName = "Light 1 Position"; 
	string Object = "PointLight"; 
	string Space = "World"; 
		int refID = 1; 
> = {100.0f, 100.0f, 100.0f}; 

float4 light1Color : LIGHTCOLOR <int LightRef = 1; string UIWidget = "None"; > = { 1.0f, 1.0f, 1.0f, 1.0f}; 
float4 light1Attenuation : Attenuation <int LightRef = 1; string UIWidget = "None"; > = { 1.0f, 1.0f, 1.0f, 1.0f}; 
float light1Hotspot : HotSpot <int LightRef = 1; string UIWidget = "None"; > = { 43.0f }; 
float light1Falloff : FallOff <int LightRef = 1; string UIWidget = "None"; > = { 45.0f }; 

#define light1Type 1
#define light1attenType 0
#define light1coneType 0
#define light1CastShadows false

//---------------------------------- 

float4x4 wvp : WorldViewProjection < string UIWidget = "None"; >;  
float4x4 worldI : WorldInverse < string UIWidget = "None"; >;  
float4x4 worldIT : WorldInverseTranspose < string UIWidget = "None"; >;  
float4x4 viewInv : ViewInverse < string UIWidget = "None"; >;  
float4x4 world : World < string UIWidget = "None"; >;  
// create the light vector 
float3 lightVec_func(float3 worldSpacePos, float3 lightVector, float3x3 objTangentXf, int lightType) 
{ 
	float3 lightVec = mul(objTangentXf, (mul((lightVector - worldSpacePos), worldI).xyz)); 
	return lightVec; 
} 


// Minnaert Diffuse Lighting 
float minnaert(float NdotL, float NdotV, float Roughness1) 
{ 
	return pow(NdotL * NdotV, Roughness1) * saturate(NdotL); 
} 

//Ward specular lighting
float Ward(float NdotL, float NdotV, float NdotH, float Roughness1)
{
	float tan2NH = -pow(tan(acos(NdotH)), 2);
	float RMS2 = Roughness1 * Roughness1;
	float Den = 6.28 * RMS2;
	float FirstTerm = exp(tan2NH / RMS2) / Den;
	float SecondTerm = 1.0f / sqrt(NdotL * NdotV);
	return FirstTerm * SecondTerm;
}		
// input from application 
	struct a2v { 
	float4 position		: POSITION; 
	float4 tangent		: TANGENT; 
	float4 binormal		: BINORMAL; 
	float4 normal		: NORMAL; 

	float2 texCoord		: TEXCOORD0; 

}; 

// output to fragment program 
struct v2f { 
        float4 position    		: POSITION; 
        float3 lightVec    		: TEXCOORD0; 
        float3 eyeVec	    	: TEXCOORD1; 

	float2 texCoord			: TEXCOORD2; 

}; 

//Diffuse and Specular Pass Vertex Shader
v2f v(a2v In, uniform float3 lightPos, uniform int lightType, uniform float3 lightDir) 
{ 
    v2f Out = (v2f)0; 
	float3x3 objTangentXf;								//build object to tangent space transform matrix 
		objTangentXf[0] = In.tangent.xyz; 
	objTangentXf[1] = -In.binormal.xyz; 
	objTangentXf[2] = In.normal.xyz; 
	float3 worldSpacePos = mul(In.position, world).xyz;	//world space position 
	Out.lightVec = lightVec_func(worldSpacePos, lightPos, objTangentXf, lightType); 
	float4 osIPos = mul(viewInv[3], worldI);			//put world space eye position in object space 
	float3 osIVec = osIPos.xyz - In.position.xyz;		//object space eye vector 
	Out.eyeVec = mul(objTangentXf, osIVec);				//tangent space eye vector passed out 
	Out.position = mul(In.position, wvp);				//transform vert position to homogeneous clip space 

	Out.texCoord = In.texCoord;						//pass through texture coordinates from channel 1 

	return Out; 
} 

//Diffuse and Specular Pass Pixel Shader
float4 f(v2f In, uniform float3 lightDir, uniform float4 lightColor, uniform float4 lightAttenuation, uniform float lightHotspot, uniform float lightFalloff, uniform int lightType, uniform int lightattenType, uniform int lightconeType, uniform bool lightCastShadows, uniform int shadowPassCount) : COLOR 
{ 
	float3 ret = float3(0,0,0); 
	float3 V = normalize(In.eyeVec);		//creating the eye vector  
	float3 L = normalize(In.lightVec);		//creating the light vector  

	float4 TextureMap_9655 = tex2D(TextureMap_9655Sampler, In.texCoord.xy);
	float3 input2 = TextureMap_9655.rgb; 


	float4 TextureMap_9840 = tex2D(TextureMap_9840Sampler, In.texCoord.xy);
	float3 input3 = TextureMap_9840.rgb; 


	float4 NormalMap_2269 = tex2D(NormalMap_2269Sampler, In.texCoord.xy);
	NormalMap_2269.xyz = NormalMap_2269.xyz * 2 - 1;		//expand to -1 to 1 range 
	NormalMap_2269.rgb = normalize(NormalMap_2269.rgb); 		//normalized the normal vector 
	float3 input8 = NormalMap_2269.rgb; 

	float3 N = input8;						//using the Normal socket  
	float3 diffuseColor = input2;			//using the Diffuse Color socket  
	float NdotL = dot(N, L);				//calculate the diffuse  
	float input12 = 1.0;				//the diffuse focus socket is empty so we just default the value to one  
	float diffuse = minnaert(NdotL, dot(N, V), input12);		//compute Minnaert lighting  
	float3 specularColor = input3;			//using the Specular Color socket 
	float Roughness1 = 0.5;					//the Roughness socket was empty - using default value 
	float3 H = normalize(L + V);			//Compute the half angle  
	float NdotH = dot(N, H);				//Compute NdotH  
	float NdotV = dot(N, V);				//Compute NdotV  
	specularColor *= Ward(NdotL, NdotV, NdotH, Roughness1);//Compute final specular color  
	ret += specularColor + diffuseColor;	//add specular and diffuse color together
	ret *= diffuse;							//multiply by diffuse shading  
	ret *= lightColor;						//multiply by the color of the light 
	float attenuation = attenuation_func(lightattenType, lightAttenuation, In.lightVec); 					//calculate the light attenuation  
	float coneangle = coneangle_func(lightconeType, lightHotspot, lightFalloff, In.lightVec, lightDir); 	//calculate the light's cone angle 
	ret *= attenuation * coneangle;			//multiply by the light decay  
	float4 done = float4(ret, 1);			//create the final ouput value 
	return done; 
} 

technique Complete  
{  
	pass light1  
    {		 
		VertexShader = compile vs_2_0 v(light1Pos,  light1Type, light1Dir); 
		ZEnable = true; 
		CullMode = ccw; 
		ZWriteEnable = true; 
		AlphaBlendEnable = false; 
		SrcBlend = SrcAlpha; 
		DestBlend = One; 
		PixelShader = compile ps_2_0 f(light1Dir, light1Color, light1Attenuation, light1Hotspot, light1Falloff, light1Type, light1attenType, light1coneType, light1CastShadows, 1); 
	}  
}    